<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { toRef } from 'vue';

const props = defineProps<{
    modelValue: number, 
    min?: number,
    max?: number,
    step?: number,
    label?: string,
    changeHandler?: boolean
}>();

const modelValue = toRef(props, 'modelValue');

const emits = defineEmits<{
    (e: 'update:modelValue', value: number):void
    (e: 'change', value: number):void
}>();

const handleChangeModelValue = (e:any)=>{
    if(props.changeHandler)
        emits('change', Number(e.target.value));
    else
        emits('update:modelValue', Number(e.target.value));
};

const color = "[&::-webkit-slider-runnable-track]:bg-gray-300 [&::-moz-range-track]:bg-gray-300 [&::-webkit-slider-thumb]:bg-gray-500 [&::-webkit-slider-thumb]:hover:ring-gray-300 [&::-moz-range-thumb]:bg-gray-500 [&::-moz-range-thumb]:border-gray-500 [&::-moz-range-thumb]:hover:ring-gray-300"

</script>
<template>
    <div class="mt-0 w-full">
        <span v-if="label">{{label}}: {{ modelValue }}</span>
        <input class="appearance-none bg-transparent w-full h-1 border-transparent [&::-webkit-slider-runnable-track]:rounded-full [&::-webkit-slider-runnable-track]:h-1 [&::-moz-range-track]:rounded-full [&::-moz-range-track]:h-1 [&::-webkit-slider-thumb]:appearance-none [&::-webkit-slider-thumb]:-mt-1.5 [&::-webkit-slider-thumb]:h-4 [&::-webkit-slider-thumb]:w-4 [&::-webkit-slider-thumb]:rounded-full [&::-moz-range-thumb]:appearance-none [&::-moz-range-thumb]:-mt-1.5 [&::-moz-range-thumb]:h-4 [&::-moz-range-thumb]:w-4 [&::-moz-range-thumb]:rounded-full  [&::-webkit-slider-thumb]:hover:ring-4  [&::-webkit-slider-thumb]:cursor-ew-resize  [&::-moz-range-thumb]:border [&::-moz-range-thumb]:hover:ring-8 [&::-moz-range-thumb]:cursor-ew-resize" :class="color" type="range" :min="props.min" :max="props.max" :step="props.step" v-model="modelValue" @change="handleChangeModelValue">
    </div>
</template>